Description

You are not allowed to see the diff between changesets if you don't have a "Browse repository" permission. However, "View
differences" buttons on RepositoriesController#show page are always shown even if you don't have the permission. In contrast, the
"View differences" tab on the RepositoriesController#revision is hidden depending on the permission.

| think the buttons should be hidden if the current user does not have a "Browse repository" permission.

root

Latest revisions

View differences

# Date Author
11 © 06/20/2010 06:13 PM schmidt adding test data for #5
10 © 05/11/2009 04:04 AM Dave Lopper Same file modified.
9 09/11/2009 04:04 AM Dave Lopper One file added.
This commits referencs
8 09/11/2007 04:04 AM Dave Lopper Refs #2
7 09/11/2007 04:02 AM Dave Lopper Removed one file.
6 09/11/2007 04:01 AM Dave Lopper Moved helloworld.rb frd

Associated revisions

Revision 18013 - 2019-03-30 07:13 - Jean-Philippe Lang

"View differences" buttons are shown in the repository page even without "Browse repository" permission (#30731).

Patch by Go MAEDA.

Revision 18017 - 2019-03-30 08:14 - Jean-Philippe Lang
Merged r18013 to 4.0-stable (#30731).

History

#1 - 2019-03-08 05:23 - Takenori TAKAKI
- File fix-30731.patch added

It seems to be able to solve this problem by adding the following condition for disp the button.

User.current.allowed_to? (:browse_repository, @repository.project)

| made a patch and attached it.

#2 - 2019-03-24 06:31 - Go MAEDA

- Target version set to Candidate for next minor release

Thank you for the patch. While reviewing the patch, | found that we don't have to show radio buttons to select revisions to show diff when "View
differences" is hidden.
IMHO, the following fix is better. It hides the radio boxes as well as the button. In addition, it is simpler.

diff --git a/app/views/repositories/_revisions.html.erb b/app/views/repositories/_revisions.html.erb

index 914999b34..514380791 100644

-—— a/app/views/repositories/_revisions.html.erb
+++ b/app/views/repositories/_revisions.html.erb
@@ -20,7 +20,7 Q@ end %>

:repository_id => Q@repository.identifier_param, :path => to_path_param(path)},

:method => :get

) do %>
—<% show_diff = revisions.size > 1 %>
+<% show_diff = revisions.size > 1 && User.current.allowed_to? (:browse_repository,

<%= submit_tag(l(:label_view_diff), :name => nil) if show_diff %>

<table class="list changesets">
<thead><tr>

#3 - 2019-03-25 03:59 - Takenori TAKAKI

Right, As you said the radio button should also be hidden.
| also thought that the proposed patch is simpler and better.

#4 - 2019-03-25 09:34 - Go MAEDA
- File test-for-30731.diff added

- Target version changed from Candidate for next minor release to 4.0.3

Setting the target version to 4.0.3.

#5 - 2019-03-27 01:38 - Go MAEDA

@repository.project) %>

- Subject changed from "View differences" buttons are shown on the repository page even if the user does not have a "Browse repository" permission

to "View differences" buttons are shown in the repository page even without "Browse repository" permission

#6 - 2019-03-30 08:14 - Jean-Philippe Lang
- Status changed from New to Closed
- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Committed, thanks.
